#! /usr/bin/perl
print "Content-type: text/html\n\n";

if ($ENV{"REQUEST_METHOD"} eq "POST") {
  read(STDIN, $datastring, $ENV{"CONTENT_LENGTH"});		
}
elsif (exists $ENV{"REQUEST_METHOD"}) {				# data from GET transaction (or HEAD or other)
  $datastring = $ENV{"QUERY_STRING"};
}
else {
  print "Offline execution detected\n";
  print "Please enter some data.\n";
  $datastring = <>;
  chomp $datastring;
  print "== data accepted == HTML output follows ==\n\n";
}

###decode######################################################
@nameValuePairs = split(/&/, $datastring);				 #step 1.
foreach $pair (@nameValuePairs) {
  ($name, $value) = split(/=/, $pair);			 			 #step 2.
  $name =~tr/+/ /;                                 #step 3.
  $name =~s/%([\da-fA-F]{2})/pack("C",hex($1))/eg; #step 3.
  $value =~tr/+/ /;                                #step 3.
  $value =~s/%([\da-fA-F]{2})/pack("C",hex($1))/eg;#step 3.
  $value =~s/[<>]//g;					#precaution
  $formHash{$name}=$value;                    		 #step 4.
}
###done decoding###############################################

### the data source #############

# OOPS below hash defined as a scalar variable

$food_price_hash = ( 	"Cheeseburger" => "1.50",
  										"Veggieburger" => "1.50",
  										"Fries" => "1.00",
  										"Drink" => "0.80" );
#################################

if($datastring eq ""){
	&printForm;   	# function to print order form page
}
else{
	&printResults;	# function to print summary page
}

##############################################################
sub printForm
{
print<<TOP;
<html>
 <head>
  <title>Order some food</title>
 </head>
 <body>
  <form action="food2.cgi" method="GET"/>
  <table border="1">
   <tr><th>Food</th><th>Quantity</th></tr>
TOP

foreach $food (keys %food_price_hash)
{
  print<<ITEM;
    <tr>
    <td>$food (\$$food_price_hash{$food})</td>
    <td><input type="text" name="$food" value="" size="5"/></td>
   </tr>
ITEM
}

print<<BOTTOM;
  </table>
  <input type="submit" value="Submit order"/>
  </form>
 </body>
</html>
BOTTOM
}
###############################################################
sub printResults
{
print <<TOP;
<html>
<head>
<title>Thank you for your order</title>
</head>
<body>

  <table border="1">
   <tr><th>Food</th><th>Quantity</th><th>Subtotal</th></tr>
TOP

$total=0;
foreach $food (keys %food_price_hash)
{
  $subtotal = sprintf "%.2f", $food_price_hash{$food}*$formHash{$food};
  $total += $subtotal;
  print<<ITEM;
    <tr>
    <td>$food (\$$food_price_hash{$food})</td>
    <td align="right">$formHash{$food}</td><td align="right">\$$subtotal</td>
   </tr>
ITEM
}

$total = sprintf "%.2f", $total;
print<<BOTTOM
    <tr>
    <td colspan="2"><b>TOTAL</td><td align="right">\$$total</td>
   </tr>
  </table>

</body>
</html>
BOTTOM
}
