#! /usr/bin/perl
print "Content-type: text/html\n\n";

if ($ENV{"REQUEST_METHOD"} eq "POST") {
  read(STDIN, $datastring, $ENV{"CONTENT_LENGTH"});		
}
elsif (exists $ENV{"REQUEST_METHOD"}) {		# data from GET transaction (or HEAD or other)
  $datastring = $ENV{"QUERY_STRING"};
}
else {
  print "Offline execution detected\n";
  print "Please enter some data.\n";
  $datastring = <>;
  chomp $datastring;
  print "== data accepted == HTML output follows ==\n\n";
}

###decode######################################################
@nameValuePairs = split(/&/, $datastring);						#step 1
foreach $pair (@nameValuePairs) {
  ($name, $value) = split(/=/, $pair);								#step 2
  $name =~tr/+/ /;                                 		#step 3
  $name =~s/%([\da-fA-F]{2})/pack("C",hex($1))/eg; 		#step 3
  $value =~tr/+/ /;                                		#step 3
  $value =~s/%([\da-fA-F]{2})/pack("C",hex($1))/eg;		#step 3
  $formHash{$name}=$value;                    				#step 4
}
###done decoding###############################################


@sizes = ("large", "medium", "small");
$default_size="medium";

%size_prices = (
  "large" => "8.00",
  "medium" => "6.00",
  "small" => "4.00"
);

%topping_prices = (
  "large" => "1.00",
  "medium" => "0.75",
  "small" => "0.50"
);

%toppings = (
	"m_pepperoni" => "Pepperoni", 
	"m_sausage"	=> "Italian Sausage", 
	"v_peppers" => "Green Bell Peppers", 
	"v_mushrooms" => "Mushrooms",
  "v_onions" => "Vidallia Onions",
  "v_olives" => "Black Olives"
);


if($datastring  eq "") {
	&printForm;				# function to print order form page
}
else {
	&processForm; 		# function to print summary page
}

#################################################################
sub printForm {
print<<TOP;
<html><head><title>Personalize a pizza</title></head>
 <body>
  <form action="pizza.cgi" method="GET" >
  <table border="1">
   <tr><th>Select size</th><th>Select ingredients</th></tr>
TOP

print " <tr><td>\n";
foreach $size (@sizes)	{
  print '<input type="radio" name="chosen_size" value="', $size, '"';

  if($size eq $default_size){
  	print ' checked="checked"';
  }
 	print " /><b>$size</b> <br/>Base Price: \$$size_prices{$size} <br/>",
 				"Each Topping: \$$topping_prices{$size}<hr/>\n";
}
print " </td><td>\n";

foreach $topping (sort keys %toppings) {
  print '<input type="checkbox" name="',$topping, '" value="yes" />',
  			"$toppings{$topping}<br/>\n";
}
print "</tr>\n";

print<<BOTTOM;
  </table>
  <input type="submit" value="Submit order"/>
  </form>
 </body>
</html>
BOTTOM
}

#################################################################
sub processForm {
print <<TOP;
<html><head><title>Thank you for choosing your pizza</title></head>
 <body>
TOP

$size = $formHash{"chosen_size"};
$total=$size_prices{$size};

print "You have selected a $size pizza with the following extra ingredients:\n<ul>";

foreach $topping (sort keys %toppings) {
  if(exists $formHash{$topping}) {
    $total = $total + $topping_prices{$size};
    print "<li>$toppings{$topping}</li>\n";
  }
}
print "</ul>\n";

$total = sprintf "%.2f", $total;
print "for a total of \$$total.\n";

print<<BOTTOM
</body>
</html>
BOTTOM
}
