#! /usr/bin/perl
print "Content-type: text/html\n\n";

%websites = (
	"amazon" => "www.amazon.com",
	"ebay" => "www.ebay.com",
	"etrade" => "www.etrade.com",
	"perl" => "www.perl.org",
	"apples" => "www.apples.com",
	"durians" => "www.durian.net",
	"oranges" => "www.oranges.com" );

@keys = keys %websites;		# extract array of keys for the web sites
$maxnumber = @keys;  		# number of keys in the hash--same as ($#keys+1)
                            # also the biggest largest number accepted in query string
print <<TOP;
<html>
<head>
<title>List of random Web sites</title>
</head>
<body>
TOP

if($ENV{"QUERY_STRING"} eq "") {
	print "<h1>Try attaching a positive integer as a query string.</h1>\n",
		  "</body></html>\n";
  	exit;
}

$number = $ENV{"QUERY_STRING"};
if(($number <1) || ($number > $maxnumber)) {
 	print "<h1>Please use a number between 1 and $maxnumber.</h1>\n",
		  "</body></html>\n";
  	exit;
}

print "<h1>Here is a list of $number websites.</h1>\n";
print "<ol>\n";

for($i=1; $i<=$number; $i++) {
  	$range = @keys;
	$randomIndex = int rand $range;
  	$randomKey = $keys[$randomIndex];
  	print "<li><a href=\"http://$websites{$randomKey}\">$randomKey</a></li>\n";
  
  	splice @keys, $randomIndex, 1;		#remove used key from @keys array
}
print "</ol>\n";

print <<BOTTOM;
</body>
</html>
BOTTOM
